#!/bin/bash

for workers in 0 3; do

    for mem in 2MB 4MB 8MB 64MB 256MB; do

        echo `date` [`date +%s`] hash $workers $mem / explain analyze

        psql tpch > hash-$workers-$mem.explain-analyze 2>&1 <<EOF
set max_parallel_workers_per_gather = $workers;
set work_mem = '$mem';
set enable_sort = off;
set random_page_cost = 1.5;
\i explain-analyze.sql
EOF

        echo `date` [`date +%s`] done

        echo `date` [`date +%s`] hash $workers $mem / query

        s=`tail -n 1 iosnoop.log | awk '{print $1}'`

        psql tpch > hash-$workers-$mem.result 2>&1 <<EOF
set max_parallel_workers_per_gather = $workers;
set work_mem = '$mem';
set enable_sort = off;
set random_page_cost = 1.5;
\timing
\i query.sql
EOF
        e=`tail -n 1 iosnoop.log | awk '{print $1}'`

        echo `date` [`date +%s`] hash $workers $mem done $s $e

        echo `date` [`date +%s`] sort $workers $mem / explain analyze

        psql tpch > sort-$workers-$mem.explain-analyze 2>&1 <<EOF
set max_parallel_workers_per_gather = $workers;
set work_mem = '$mem';
set enable_hashagg = off;
set random_page_cost = 1.5;
\i explain-analyze.sql
EOF

        echo `date` [`date +%s`] done

        echo `date` [`date +%s`] sort $workers $mem / query

        s=`tail -n 1 iosnoop.log | awk '{print $1}'`

        psql tpch > sort-$workers-$mem.result 2>&1 <<EOF
set max_parallel_workers_per_gather = $workers;
set work_mem = '$mem';
set enable_hashagg = off;
set random_page_cost = 1.5;
\timing
\i query.sql
EOF

        e=`tail -n 1 iosnoop.log | awk '{print $1}'`

        echo `date` [`date +%s`] sort $orkers $mem done $s $e

    done;

done

